; -----------------------------------------------------------------------------
;	{XG1̏
; -----------------------------------------------------------------------------

		.include	"sca_info.asm"

		.area	CODE (ABS)

		.globl	enemy_get_cos
		.globl	random
		.globl	enemy_shot_start
		.globl	player_info
		.globl	sprite_set_color
		.globl	sprite_attribute_table
		.globl	change_crash_check_routine

; -----------------------------------------------------------------------------
;	{X1̈ړ
;	input:
;		ix	...	G̃AhX
;	output
;		Ȃ
;	break
;		a,f,b,c,h,l
; -----------------------------------------------------------------------------
enemy_boss1_move::
		; ̃{X쒆łȂΉȂ
		ld		a, SCA_INFO_ENEMY_POWER(ix)
		or		a
		jr		nz, enemy_boss1_move_active
enemy_boss1_inactive:
		ld		SCA_INFO_YH(ix), #212			; \
		ld		SCA_INFO_YH2(ix), #212			; \
		ld		SCA_INFO_YH3(ix), #212			; \
		ld		SCA_INFO_YH4(ix), #212			; \
		ld		SCA_INFO_YH5(ix), #212			; \
		ld		SCA_INFO_YH6(ix), #212			; \
		ld		SCA_INFO_YH7(ix), #212			; \
		ld		SCA_INFO_YH8(ix), #212			; \
		ld		SCA_INFO_ENEMY_POWER(ix), #0	; 쓮łȂ
		ld		SCA_INFO_ENEMY_POWER3(ix), #0	; 쓮łȂ
		ld		SCA_INFO_ENEMY_POWER5(ix), #0	; 쓮łȂ
		ld		SCA_INFO_ENEMY_POWER7(ix), #0	; 쓮łȂ
		ret
enemy_boss1_move_active:
		; Yʑp𓾂
		ld		l, SCA_INFO_ENEMY_STATE_L(ix)
		ld		h, SCA_INFO_ENEMY_STATE_H(ix)
		; Yʑp 90 * (random & 7)/128 [x] 炷
		ex		de, hl
		call	random
		ld		h, #0
		ld		a, l
		and		#7
		ld		l, a
		add		hl, de
		; YʑpXV
		ld		SCA_INFO_ENEMY_STATE_L(ix), l
		ld		SCA_INFO_ENEMY_STATE_H(ix), h
		; b = sin( ʑp )
		call	enemy_get_cos
		; a = b + 96 - 16
		ld		a, #96 - 16
		add		a, b
		; YWXV
		ld		SCA_INFO_YH(ix), a
		ld		SCA_INFO_YH2(ix), a
		ld		SCA_INFO_YH3(ix), a
		ld		SCA_INFO_YH4(ix), a
		add		a, #16
		ld		SCA_INFO_YH5(ix), a
		ld		SCA_INFO_YH6(ix), a
		ld		SCA_INFO_YH7(ix), a
		ld		SCA_INFO_YH8(ix), a
		; Xʑp𓾂
		ld		l, SCA_INFO_ENEMY_STATE_L2(ix)
		ld		h, SCA_INFO_ENEMY_STATE_H2(ix)
		; Xʑp 90 * (random & 7)/128 [x] 炷
		ex		de, hl
		call	random
		ld		h, #0
		ld		a, l
		and		#7
		ld		l, a
		add		hl, de
		; XʑpXV
		ld		SCA_INFO_ENEMY_STATE_L2(ix), l
		ld		SCA_INFO_ENEMY_STATE_H2(ix), h
		; c = cos( ʑp )
		call	enemy_get_cos
		; a = c + 96 - 16
		ld		a, #96 - 16
		add		a, c
		; XWXV
		ld		SCA_INFO_XH(ix), a
		ld		SCA_INFO_XH2(ix), a
		ld		SCA_INFO_XH5(ix), a
		ld		SCA_INFO_XH6(ix), a
		add		a, #16
		ld		SCA_INFO_XH3(ix), a
		ld		SCA_INFO_XH4(ix), a
		ld		SCA_INFO_XH7(ix), a
		ld		SCA_INFO_XH8(ix), a

enemy_boss1_move_fire:
		; e𔭎˂^C~OH
		ld		a, SCA_INFO_ENEMY_SHOT_TIMING(ix)
		inc		a
		and		#7
		ld		SCA_INFO_ENEMY_SHOT_TIMING(ix), a
		jr		nz, enemy_boss1_move_end					; ˂̃^C~OłȂ enemy_boss1_move_end 
		; ˏ
		ld		iy, #player_info
		call	enemy_shot_start
enemy_boss1_move_end:
enemy_boss1_move_dummy:
		ret

; -----------------------------------------------------------------------------
;	{X1̓oꏈ
;		iy	... G̃AhX
;	output
;		Ȃ
;	break
;		a,b,d,e,f,h,l,iy
; -----------------------------------------------------------------------------
enemy_boss1_start::
		; 蔻{Xpɐ؂ւ
		ld		a, #1
		call	change_crash_check_routine
		; {XV[hXV
		ld		a, #2*32
		ld		SCA_INFO_ENEMY_POWER(iy), a
		ld		SCA_INFO_ENEMY_POWER3(ix), a
		ld		SCA_INFO_ENEMY_POWER5(ix), a
		ld		SCA_INFO_ENEMY_POWER7(ix), a
		; ʑXV
		ld		hl, #384							; 270x
		ld		SCA_INFO_ENEMY_STATE_L(iy), l
		ld		SCA_INFO_ENEMY_STATE_H(iy), h
		ld		SCA_INFO_ENEMY_STATE_L2(iy), l
		ld		SCA_INFO_ENEMY_STATE_H2(iy), h
		; YWXV
		xor		a
		ld		SCA_INFO_YH(iy), a
		ld		SCA_INFO_YH2(iy), a
		ld		SCA_INFO_YH3(iy), a
		ld		SCA_INFO_YH4(iy), a
		add		a, #16
		ld		SCA_INFO_YH5(iy), a
		ld		SCA_INFO_YH6(iy), a
		ld		SCA_INFO_YH7(iy), a
		ld		SCA_INFO_YH8(iy), a
		; XWXV
		ld		a, #96 - 16
		ld		SCA_INFO_XH(iy), a
		ld		SCA_INFO_XH2(iy), a
		ld		SCA_INFO_XH5(iy), a
		ld		SCA_INFO_XH6(iy), a
		add		a, #16
		ld		SCA_INFO_XH3(iy), a
		ld		SCA_INFO_XH4(iy), a
		ld		SCA_INFO_XH7(iy), a
		ld		SCA_INFO_XH8(iy), a
		ld		hl, #enemy_boss1_move
		ld		SCA_INFO_ENEMY_MOVE_L(iy), l
		ld		SCA_INFO_ENEMY_MOVE_H(iy), h
		ld		hl, #enemy_boss1_move_dummy
		ld		de, #SCA_INFO_SIZE * 2
		add		iy, de
		ld		SCA_INFO_ENEMY_MOVE_L(iy), l
		ld		SCA_INFO_ENEMY_MOVE_H(iy), h
		add		iy, de
		ld		SCA_INFO_ENEMY_MOVE_L(iy), l
		ld		SCA_INFO_ENEMY_MOVE_H(iy), h
		add		iy, de
		ld		SCA_INFO_ENEMY_MOVE_L(iy), l
		ld		SCA_INFO_ENEMY_MOVE_H(iy), h
		add		iy, de
		ld		SCA_INFO_ENEMY_MOVE_L(iy), l
		ld		SCA_INFO_ENEMY_MOVE_H(iy), h
		add		iy, de
		ld		SCA_INFO_ENEMY_MOVE_L(iy), l
		ld		SCA_INFO_ENEMY_MOVE_H(iy), h
		; XvCg̐FύX
		ld		a, #2
		ld		c, #0x01
		call	sprite_set_color
		ld		a, #3
		ld		c, #0x48
		call	sprite_set_color
		ld		a, #4
		ld		c, #0x01
		call	sprite_set_color
		ld		a, #5
		ld		c, #0x48
		call	sprite_set_color
		ld		a, #6
		ld		c, #0x01
		call	sprite_set_color
		ld		a, #7
		ld		c, #0x48
		call	sprite_set_color
		ld		a, #8
		ld		c, #0x01
		call	sprite_set_color
		ld		a, #9
		ld		c, #0x48
		call	sprite_set_color
		; XvCgp^[ԍύX
		ld		hl, #(sprite_attribute_table + 2 + 2*4)
		ld		de, #4
		;		p^[ԍ
		ld		(hl), #(16 * 4)
		add		hl, de
		ld		(hl), #(17 * 4)
		add		hl, de
		ld		(hl), #(18 * 4)
		add		hl, de
		ld		(hl), #(19 * 4)
		add		hl, de
		ld		(hl), #(20 * 4)
		add		hl, de
		ld		(hl), #(21 * 4)
		add		hl, de
		ld		(hl), #(22 * 4)
		add		hl, de
		ld		(hl), #(23 * 4)
		ret
