; -----------------------------------------------------------------------------
;	XvCg\XV
; -----------------------------------------------------------------------------

		.include	"sca_info.asm"

		.globl		player_invincibility
		.globl		software_timer

		.area	CODE (ABS)

; -----------------------------------------------------------------------------
;	DRAM̃XvCgAgr[ge[uC[W
;	input:
;		Ȃ
;	output
;		Ȃ
;	break
;		a,b,c,d,e,f
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
sprite_init::
		; XvCgAgr[ge[u 212 ŏ
		ld		hl, #sprite_attribute_table
		ld		de, #(sprite_attribute_table + 1)
		ld		bc, #(4*32 - 1)
		ld		(hl), #212
		ldir
		; XvCgp^[ԍ
		ld		b, #32
		ld		de, #sprite_pattern_data
		ld		hl, #(sprite_attribute_table + 2)
sprite_init_loop1:
		ld		a, (de)
		ld		(hl), a
		inc		de
		inc		hl
		inc		hl
		inc		hl
		inc		hl
		djnz	sprite_init_loop1
		; XvCgJ[
		ld		b, #32						; 32
		xor		a							; XvCgԍl 0
		ld		hl, #sprite_color_data
sprite_init_loop2:
		push	hl
		push	bc
		push	af
		ld		c, (hl)						; c = Ff[^
		call	sprite_set_color			; COLOR SPRITE(a) = c
		pop		af
		pop		bc
		pop		hl
		inc		hl							; ̐Ff[^
		inc		a							; ̃XvCg
		djnz	sprite_init_loop2
		ret

; -----------------------------------------------------------------------------
;	XvCg`
;	input:
;		Ȃ
;	output
;		Ȃ
;	break
;		S
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
sprite_pattern_init::
		ld		hl, #sprite_pattern
		ld		de, #SPRITE_GENERATOR
		ld		bc, #(8*4*24)
		jp		LDIRVM

; -----------------------------------------------------------------------------
;	XvCgJ[Zbg
;	input
;		a ...	XvCgԍ(0`31)
;		c ...	Ff[^
;	output
;		Ȃ
;	break
;		S
;	comment
;		COLOR SPRITE(a) = c ɑ
; -----------------------------------------------------------------------------
sprite_set_color::
		; hl = SPRITE_COLOR + a * 16
		ld		hl, #SPRITE_COLOR
		rlca			; ctO͕K 0
		rlca			; ctO͕K 0
		rlca			; ctO͕K 0
		rlca
		jr		nc, sprite_set_color_skip1
		inc		h
sprite_set_color_skip1:
		ld		l, a	; SPRITE_COLOR ̉8bit  0x00 Ȃ̂ a+l  a ƓBȂ̂őŗǂB
		; a = Ff[^
		ld		a, c
		; bc = 16
		ld		bc, #16
		jp		FILVRM

; -----------------------------------------------------------------------------
;	DRAM̃XvCgAgr[ge[uC[WXV
;	input:
;		ix	...	e[ũAhX
;	output
;		Ȃ
;	break
;		S
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
sprite_update::
		; e[u̍WDRAM̃Agr[ge[uC[W֓]
		ld		de, #SCA_INFO_SIZE
		ld		hl, #sprite_attribute_table
		ld		b, #(2+6*2+3+SCA_SHOT_COUNT)		; @(2), G(6*2), @e(3)AGe(SCA_SHOT_COUNT), v32
sprite_update_loop:
		ld		a, SCA_INFO_YH(ix)
		ld		(hl), a
		inc		hl
		ld		a, SCA_INFO_XH(ix)
		ld		(hl), a
		inc		hl
		inc		hl
		inc		hl
		add		ix, de
		djnz	sprite_update_loop
sprite_update_player:
		; @GԂH
		ld		a, (player_invincibility)
		or		a
		jr		z, sprite_update_transfer
		inc		a
		jr		z, sprite_update_transfer
		; 1/30̃^C~OH
		ld		a, (software_timer)
		and		#1
		jr		z, sprite_update_transfer
		; @\ɂi_łj
		ld		a, #212
		ld		(sprite_attribute_table + 0), a
		ld		(sprite_attribute_table + 4), a
sprite_update_transfer:
		; Agr[ge[uC[WVRAM֓]
		ld		hl, #sprite_attribute_table
		ld		de, #SPRITE_ATTRIBUTE
		ld		bc, #(4*32)
		jp		LDIRVM

; -----------------------------------------------------------------------------
;	XvCgS
;	input:
;		Ȃ
;	output
;		Ȃ
;	break
;		S
;	comment
;		Ȃ
; -----------------------------------------------------------------------------
sprite_all_clear::
		ld		b, #32
		ld		hl, #sprite_attribute_table
		ld		a, #212
sprite_all_clear_loop:
		ld		(hl), a
		inc		hl
		inc		hl
		inc		hl
		inc		hl
		djnz	sprite_all_clear_loop
		jp		sprite_update_transfer

sprite_attribute_table::
		.ds		4*32				; (+0:YW, +1:XW, +2:p^[ԍ, +3:gp)  32

sprite_pattern:
		.db		#0x00, #0x01, #0x00, #0x03, #0x03, #0x03, #0x03, #0x07	; @-1	0
		.db		#0x67, #0x7F, #0x6F, #0x6F, #0x63, #0x3D, #0xC4, #0x03
		.db		#0x00, #0x80, #0x80, #0x40, #0x40, #0xC0, #0xC0, #0xE0
		.db		#0x6A, #0x72, #0x7A, #0x7A, #0x42, #0x7A, #0x46, #0x80

		.db		#0x01, #0x03, #0x03, #0x06, #0x06, #0x04, #0x04, #0x4C	; @-2	1
		.db		#0xCE, #0xCF, #0xDF, #0xDF, #0xDF, #0xC3, #0x03, #0x00
		.db		#0x00, #0x00, #0x00, #0x80, #0x80, #0x00, #0x00, #0x04
		.db		#0x84, #0xAC, #0xBC, #0xBC, #0xBC, #0x84, #0x80, #0x00

		.db		#0x00, #0x20, #0x70, #0x70, #0x70, #0x70, #0x70, #0x70	; @e	2
		.db		#0x70, #0x30, #0x60, #0x20, #0x40, #0x20, #0x00, #0x00
		.db		#0x00, #0x08, #0x1C, #0x1C, #0x1C, #0x1C, #0x1C, #0x1C
		.db		#0x1C, #0x0C, #0x18, #0x08, #0x10, #0x08, #0x00, #0x00

		.db		#0x03, #0x0D, #0x17, #0x3F, #0x5F, #0x7F, #0xBF, #0xFF	; G1-1		3
		.db		#0xBF, #0x7F, #0x54, #0x3F, #0x1D, #0x0E, #0x03, #0x00
		.db		#0x80, #0x60, #0xD0, #0xF8, #0xDC, #0xFC, #0xD6, #0xDA
		.db		#0xA2, #0x0C, #0x94, #0x28, #0x50, #0x60, #0x80, #0x00

		.db		#0x00, #0x03, #0x0F, #0x1F, #0x3F, #0x3F, #0x7F, #0x7F	; G1-2		4
		.db		#0x7F, #0x3F, #0x3F, #0x00, #0x02, #0x01, #0x00, #0x00
		.db		#0x00, #0x80, #0xE0, #0xE0, #0xE0, #0xE0, #0xE8, #0xE4
		.db		#0xDC, #0xF8, #0x78, #0xF0, #0xE0, #0x80, #0x00, #0x00

		.db		#0x00, #0x00, #0x00, #0x00, #0x03, #0x07, #0x0F, #0x0F	; Ge		5
		.db		#0x0F, #0x0F, #0x07, #0x03, #0x00, #0x00, #0x00, #0x00
		.db		#0x00, #0x00, #0x00, #0x00, #0xC0, #0xE0, #0xF0, #0xF0
		.db		#0xF0, #0xF0, #0xE0, #0xC0, #0x00, #0x00, #0x00, #0x00

		.db		#0x60, #0xF0, #0xFC, #0xFF, #0x7F, #0x3B, #0x35, #0x1A	; G2A-1	6
		.db		#0x1C, #0x3A, #0x34, #0x78, #0x7C, #0x3F, #0x18, #0x00
		.db		#0x00, #0x00, #0x1C, #0xFE, #0xFD, #0xEA, #0x4C, #0x10
		.db		#0x20, #0x20, #0x10, #0x98, #0x08, #0x0C, #0x9C, #0x78

		.db		#0x00, #0x60, #0x70, #0x7C, #0x3F, #0x1F, #0x1F, #0x0F	; G2A-2	7
		.db		#0x0F, #0x1F, #0x1F, #0x3F, #0x3F, #0x18, #0x00, #0x00
		.db		#0x00, #0x00, #0x00, #0x1C, #0xFE, #0xFC, #0xF0, #0xE0
		.db		#0xC0, #0xC0, #0xE0, #0xF0, #0xF0, #0xF8, #0x78, #0x00

		.db		#0x00, #0x30, #0x7C, #0x7F, #0x7F, #0x35, #0x3A, #0x34	; G2B-1	8
		.db		#0x38, #0x34, #0x78, #0xF9, #0xF8, #0xF3, #0x4C, #0x30
		.db		#0x0E, #0x1F, #0x7F, #0xF5, #0xEA, #0xC4, #0x88, #0x10
		.db		#0x20, #0xA0, #0x10, #0x10, #0x08, #0x88, #0x70, #0x00

		.db		#0x00, #0x00, #0x30, #0x3C, #0x3F, #0x1F, #0x1F, #0x1F	; G2B-2	9
		.db		#0x1F, #0x1F, #0x3F, #0x7F, #0x7F, #0x7C, #0x30, #0x00
		.db		#0x00, #0x0E, #0x1E, #0x7E, #0xFC, #0xF8, #0xF0, #0xE0
		.db		#0xC0, #0xC0, #0xE0, #0xE0, #0xF0, #0x70, #0x00, #0x00

		.db		#0x7F, #0xFF, #0xC5, #0x40, #0x60, #0x20, #0x31, #0x17	; G3-1		10
		.db		#0x1F, #0x0E, #0x0F, #0x06, #0x06, #0x02, #0x03, #0x01
		.db		#0xFE, #0xFF, #0xFF, #0xFE, #0x6A, #0xD4, #0x84, #0x08
		.db		#0x08, #0x10, #0x10, #0x20, #0x20, #0x40, #0x40, #0x80

		.db		#0x00, #0x7F, #0x7F, #0x3F, #0x3F, #0x1F, #0x1F, #0x0F	; G3-2		11
		.db		#0x0F, #0x07, #0x07, #0x03, #0x03, #0x01, #0x01, #0x00
		.db		#0x00, #0xFE, #0xFE, #0xFC, #0xFC, #0xF8, #0xF8, #0xF0
		.db		#0xF0, #0xE0, #0xE0, #0xC0, #0xC0, #0x80, #0x80, #0x00

		.db		#0x00, #0x00, #0x13, #0x37, #0x0E, #0x1B, #0x93, #0x1E	; A-1	12
		.db		#0x2F, #0x1A, #0x3D, #0x3F, #0x47, #0x0E, #0x31, #0x00
		.db		#0x40, #0x10, #0x74, #0xCC, #0xFE, #0xD8, #0xB8, #0xF8
		.db		#0x70, #0xF4, #0xCC, #0xF8, #0xB8, #0x30, #0xC4, #0x00

		.db		#0x00, #0x00, #0x1B, #0x39, #0x31, #0x0C, #0xEC, #0x03	; A-2	13
		.db		#0x37, #0x27, #0x02, #0x30, #0x79, #0x71, #0x04, #0x00
		.db		#0x40, #0x58, #0x38, #0x30, #0x02, #0x64, #0x40, #0x10
		.db		#0x98, #0x38, #0x30, #0xC0, #0xC0, #0xC8, #0x04, #0x00

		.db		#0x20, #0x7D, #0x5B, #0xE7, #0xCE, #0x74, #0xDF, #0xFF	; B-1	14
		.db		#0x6F, #0x5A, #0x74, #0x49, #0xC7, #0xAE, #0x56, #0x38
		.db		#0x48, #0xFC, #0xD4, #0x4F, #0xBE, #0xF2, #0xBC, #0x7C
		.db		#0x36, #0x7A, #0xE6, #0xCE, #0xB6, #0x1C, #0xBA, #0xE7

		.db		#0xA1, #0x7F, #0x7F, #0xFF, #0xF1, #0xEF, #0xEF, #0xEF	; B-2	15
		.db		#0xFF, #0x6F, #0x4F, #0xF6, #0xF9, #0xF9, #0xFF, #0x7B
		.db		#0xCC, #0xFE, #0xFF, #0xBB, #0x7B, #0x7E, #0xF4, #0xB6
		.db		#0xFE, #0xBF, #0x7B, #0xF6, #0xCE, #0xFE, #0xFE, #0xEF

		.db		#0x00, #0x00, #0x00, #0x01, #0x02, #0x03, #0x04, #0x05	; {X1-1
		.db		#0x07, #0x06, #0x0D, #0x0F, #0x0F, #0x0F, #0x0F, #0x0F
		.db		#0x07, #0x3A, #0xDF, #0x7F, #0xFF, #0xFF, #0xFF, #0x5F
		.db		#0xFB, #0xFC, #0xFE, #0xC7, #0xA7, #0xBF, #0x9F, #0xFF

		.db		#0x00, #0x00, #0x00, #0x00, #0x01, #0x01, #0x03, #0x02	; {X1-2
		.db		#0x01, #0x03, #0x06, #0x04, #0x04, #0x04, #0x06, #0x07
		.db		#0x00, #0x07, #0x3F, #0xFF, #0xFF, #0xFF, #0xFF, #0xA3
		.db		#0xFD, #0x07, #0x03, #0x3B, #0x7B, #0x77, #0x6F, #0x1F

		.db		#0xE0, #0x9C, #0x43, #0xE1, #0xD0, #0xE9, #0xD0, #0xEB	; {X1-E1
		.db		#0x45, #0x9F, #0xBF, #0xA3, #0x65, #0xBD, #0x39, #0x9F
		.db		#0x00, #0x00, #0x00, #0x80, #0xC0, #0x40, #0xE0, #0xE0
		.db		#0x60, #0xA0, #0xD0, #0xD0, #0xD0, #0xD0, #0xD0, #0x90

		.db		#0x00, #0xE0, #0xFC, #0xFE, #0xFF, #0xFE, #0xFF, #0xF4	; {X1-E2
		.db		#0xFF, #0xE0, #0xC0, #0xDC, #0xDA, #0xE2, #0xF6, #0xF8
		.db		#0x00, #0x00, #0x00, #0x00, #0x00, #0x80, #0x00, #0x00
		.db		#0x80, #0xC0, #0x60, #0x20, #0x20, #0x20, #0x60, #0xE0

		.db		#0x0B, #0x04, #0x03, #0x01, #0x01, #0x01, #0x01, #0x00	; {X1-1
		.db		#0x00, #0x00, #0x00, #0x00, #0x00, #0x00, #0x00, #0x00
		.db		#0xFF, #0x1F, #0xCF, #0x2F, #0xEF, #0xFE, #0xFF, #0xFF
		.db		#0xFF, #0xFF, #0x6F, #0x7D, #0x3E, #0x15, #0x0C, #0x03

		.db		#0x07, #0x03, #0x00, #0x00, #0x00, #0x00, #0x00, #0x00	; {X1-2
		.db		#0x00, #0x00, #0x00, #0x00, #0x00, #0x00, #0x00, #0x00
		.db		#0xFD, #0xF9, #0x39, #0xDB, #0xDF, #0xC7, #0xD0, #0x4A
		.db		#0x50, #0x4A, #0x30, #0x3F, #0x1F, #0x0F, #0x03, #0x00

		.db		#0x4F, #0xE0, #0x63, #0xA5, #0x46, #0x9D, #0xF6, #0xDD	; {X1-E1
		.db		#0xF7, #0xDD, #0xF6, #0x06, #0x8C, #0x18, #0x70, #0xC0
		.db		#0x30, #0x60, #0xC0, #0x80, #0x80, #0x80, #0x80, #0x00
		.db		#0x00, #0x00, #0x00, #0x00, #0x00, #0x00, #0x00, #0x00

		.db		#0xBF, #0x9F, #0x9C, #0xDA, #0xF9, #0xE2, #0x09, #0xA2	; {X1-E2
		.db		#0x08, #0xA2, #0x08, #0xF8, #0xF0, #0xE0, #0x80, #0x00
		.db		#0xC0, #0x80, #0x00, #0x00, #0x00, #0x00, #0x00, #0x00
		.db		#0x00, #0x00, #0x00, #0x00, #0x00, #0x00, #0x00, #0x00

sprite_pattern_data:
		.db		#0 , #4 , #12, #16, #24, #28, #32, #36
		.db		#40, #44, #48, #52, #56, #60, #20, #20
		.db		#20, #20, #20, #20, #20, #20, #20, #20
		.db		#20, #20, #20, #20, #20, #8 , #8 , #8 

sprite_color_data:
		.db		#0x01, #0x4E, #0x01, #0x44, #0x01, #0x44, #0x01, #0x44
		.db		#0x01, #0x44, #0x01, #0x44, #0x01, #0x44, #0x04, #0x04
		.db		#0x04, #0x04, #0x04, #0x04, #0x04, #0x04, #0x04, #0x04
		.db		#0x04, #0x04, #0x04, #0x04, #0x04, #0x06, #0x06, #0x06
